.nolist
include \masm32\include\masm32rt.inc
include \masm32\macros\ucmacros.asm
include \masm32\include\shlwapi.inc
includelib \masm32\lib\shlwapi.lib

.686
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
LOOP_COUNT	= 100000		; 1000000 would be a typical value

wInstrDLL MACRO args:VARARG
  ucInstr=128
  tmp$ CATSTR <Myarg=>, <args>
	% echo tmp$
  EXITM InstrDLL(args)
ENDM 
ucInstr=0
InstrDLL MACRO sPos, Src$, Sub$, sMode
LOCAL last_imm, sm1$
echo AAA
tmp$ CATSTR <sP=>, <sPos>, <, Sr=>, <Src$>, <, Su=>, <Sub$>, <, sM=>, <sMode>
% echo tmp$

  push sMode+ucInstr	;; A: 4 args, easiest case
  push reparg_offset(Sub$)
  push reparg_offset(Src$)
  push sPos
  ucInstr=0		;; restore mode
  call ptrInstr		;; invoke InstrCi, sPos, reparg_offset(Src$), reparg_offset(Sub$), sMode
  EXITM <edx>	;; relative pos in edx, absolute in eax
ENDM

reparg_offset MACRO arg:REQ
LOCAL nustr, quot, ct
	ct = 0
	quot SUBSTR <arg>, 1, 1
	ifidn quot,<">				;; if 1st char double quote
		ct=1
	endif
	ifidn quot,<'>				;; if 1st char single quote
		ct=1
	endif
	if ct
		.data
		align 4
		nustr db arg, 0
		.code
		EXITM <offset nustr>	;; append name to ADDR operator
	else
		EXITM <arg>			;; else return arg
	endif
ENDM

; use together with [url=MbMiniDll.asc]MbMiniDll[/url]

.data?
hDll	dd ?
ptrInstr	dd ?
wSrc	dd ?
wPat	dd ?

.code
start:
	mov wSrc, uni$("my other brother darryl my other brother darryl my other brother darryl my other brother darryl xxxx")
	mov wPat, uni$("darryl xxxx")
	mov hDll, rv(LoadLibrary, chr$("MbMiniDll"))		; rv is the retval macro ([url=\masm32\macros\macros.asm#"rv macro"]source[/url]), which returns eax
	.if eax
		mov ptrInstr, rv(GetProcAddress, hDll, chr$("InstrDLL"))
		.if eax
			push 1
			call ShowCpu	; print brand string and SSE level
			counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				mov eax, wInstrDLL(1, wSrc, wPat, 0)
			counter_end
			print str$(eax), 9, "cycles for wInstr (MasmBasic)", 13, 10

			counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				invoke StrStrIW, wSrc, wPat
			counter_end
			print str$(eax), 9, "cycles for StrStrIW", 13, 10, 10
			inkey "--- done ---"
		.else
			invoke MessageBox, 0, chr$("InstrDLL not found"), 0, MB_OK
		.endif
		invoke FreeLibrary, hDll
	.else
		invoke MessageBox, 0, chr$("DLL not found"), 0, MB_OK
	.endif
	exit

; select the two lines and press Control X to cut
; code for printing brand string and SSE level
ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp


end start

OPT_Tmp2Asm	1
